﻿local mastery, haste, crit, spd 	= 0, 0, 0, 0
local me,class,spec					= false, 0, 0
local timer 						= 0
local event_type,source_GUID,dest_GUID,spell
local colors
local dot_damage, targets			= {}, {}
local player_resource_id, primary_resource_treshold, execute_percent
local active_frames					= {}
local in_combat						= false
AffDotsO = {
	affliction	= 1,
	demonology	= 1,
	hide 		= false,
	layout 		= "horizontal",
	text 		= "relative",
	icon_pos 	= 0,
	hide_text	= false,
	hide_icons	= false,
	focus 		= false,
	coe 		= false,
	hp 			= false,
	haunt 		= false,
	color1		= {0,0.5,0},
	color2 		= {0,0,0.5},
	color3 		= {0.5,0,0},
	color4 		= {0,0,0},
	color6		= {0.5,0.5,0},
	color7		= {0.5,0.5,0},
	agony_order = 0,
	corr_order 	= 1,
	ua_order 	= 2,
	haunt_order = 3,
	demo_corr 	= 0,
	demo_doom 	= 1,
	destro_immo	= 0,
	scale 		= 1,
	focus_scale = 0.8,
	color_switch= 1.2,
	transparency= 0.5,
}

local m		= AffDotsTarget
local f		= AffDotsFocus
m:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving()
		self.isMoving = true
	end
end)
m:SetScript("OnMouseUp", function(self, button)
	local p,_,rp, x, y = self:GetPoint()
	AffDotsO.p = p
	AffDotsO.rp = rp
	AffDotsO.x = x
	AffDotsO.y = y
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing()
		self:SetUserPlaced(false)
		self.isMoving = false
	end
end)
f:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving()
		self.isMoving = true
	end
end)
f:SetScript("OnMouseUp", function(self, button)
	local p,_,rp, x, y = self:GetPoint()
	AffDotsO.focus_p = p
	AffDotsO.focus_rp = rp
	AffDotsO.focus_x = x
	AffDotsO.focus_y = y
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing()
		self:SetUserPlaced(false)
		self.isMoving = false
	end
end)

local function Round(num) return math.floor(num+.5) end

local function CombatLog(event_type,spell,dest_GUID)
	if class=="WARLOCK" then
		if spec==1 then
			if(event_type == "SPELL_DAMAGE" and spell == 77799) then
				targets[tostring(dest_GUID).."172"] = {dot_damage["172"],GetTime()}
				targets[tostring(dest_GUID).."30108"] = {dot_damage["30108"],GetTime()}
			elseif(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
				if(spell == 172 or spell == 87389) then
					targets[tostring(dest_GUID).."172"] = {dot_damage["172"],GetTime()}
				elseif(spell == 980) then
					targets[tostring(dest_GUID).."980"] = {dot_damage["980"],GetTime()}
				elseif(spell == 30108) then
					targets[tostring(dest_GUID).."30108"] = {dot_damage["30108"],GetTime()}
				end
			end
		elseif spec==2 then
			if(event_type == "SPELL_DAMAGE" and spell == 112089) then
				targets[tostring(dest_GUID).."172"] = {dot_damage["172"],GetTime()}
			elseif(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
				if(spell == 172) then
					targets[tostring(dest_GUID).."172"] = {dot_damage["172"],GetTime()}
				elseif(spell == 603) then
					targets[tostring(dest_GUID).."603"] = {dot_damage["603"],GetTime()}
				end
			end
		elseif spec==3 then
			
		end
	end
end

local function GetDotDmg()
	local mas = GetMastery()
	local has = GetRangedHaste()
	local cri = GetSpellCritChance(6)
	local dmg = GetSpellBonusDamage(6)
	if( mas ~= mastery or has ~= haste or cri ~= crit or dmg ~= spd) then
		mastery = mas;
		haste 	= has;
		crit 	= cri;
		spd 	= dmg;
	else
		return
	end
	
	local damage_bonus, tick_every, ticks, duration, damage, dps, meta_bonus

	if class == "WARLOCK" then
		if spec==1 then --Affliction
			damage_bonus 		= (1+crit/100)*(1+(mastery*3.1)/100)
			tick_every 			= 2/(1+(haste/100))

			ticks 				= Round(24/tick_every)
			duration 			= ticks * tick_every
			damage				= ticks*(280+spd*0.26)*damage_bonus
			dps					= Round(damage/duration)
			dot_damage["980"]	= Round(dps/100)/10

			ticks 				= Round(18/tick_every)
			duration 			= ticks * tick_every
			damage		 		= (1926+ticks*spd*0.2)*damage_bonus
			dps					= Round(damage/duration)
			dot_damage["172"]	= Round(dps/100)/10

			ticks 				= Round(14/tick_every)
			duration 			= ticks * tick_every
			damage 				= (1792+ticks*spd*0.24)*damage_bonus
			dps		 			= Round(damage/duration)
			dot_damage["30108"]	= Round(dps/100)/10

		elseif spec==2 then --Demonology
			damage_bonus 		= (1+crit/100)*(1+(mastery)/100)
			meta_bonus			= (1+crit/100)*(1+(mastery*3)/100)
			
			tick_every 			= 2/(1+(haste/100))
			ticks 				= Round(18/tick_every)
			duration 			= ticks * tick_every
			damage		 		= (1926+ticks*spd*0.2)*damage_bonus
			dps					= Round(damage/duration)
			dot_damage["172"]	= Round(dps/100)/10
			
			tick_every 			= 15/(1+(haste/100))
			ticks 				= Round(60/tick_every)
			duration 			= ticks * tick_every
			damage		 		= (1068+spd)*meta_bonus*ticks
			dps					= Round(damage/duration)
			dot_damage["603"]	= Round(dps/100)/10
		elseif spec==3 then --Destruction
			
		end
	end
end

local function SetText(f)
	if f.d.t == "dot" then
		local _,_,_,_,_,duration,expires = UnitDebuff(f.d.target, f.d.spell_name,f.d.rank,"player")
		if duration then
			local current 		= dot_damage[f.d.spell]
			if not targets[tostring(UnitGUID(f.d.target))..f.d.spell] then return end
			local on_target 	= targets[tostring(UnitGUID(f.d.target))..f.d.spell][1]
			local duration_left = expires - GetTime()
			if not AffDotsO.hide_icons then f.cd:SetCooldown(expires-duration, duration) end

			if(on_target < current  and duration_left <= f.d.pandemic) then
				f.bg:SetTexture(colors[1][1],colors[1][2],colors[1][3],AffDotsO.transparency)
			elseif(on_target*AffDotsO.color_switch < current and duration_left > f.d.pandemic) then
				f.bg:SetTexture(colors[2][1],colors[2][2],colors[2][3],AffDotsO.transparency)
			elseif(on_target == current and duration_left <= f.d.pandemic) then
				f.bg:SetTexture(colors[6][1],colors[6][2],colors[6][3],AffDotsO.transparency)
			elseif(on_target > current and duration_left <= f.d.pandemic) then
				f.bg:SetTexture(colors[7][1],colors[7][2],colors[7][3],AffDotsO.transparency)
			else
				f.bg:SetTexture(colors[3][1],colors[3][2],colors[3][3],AffDotsO.transparency)
			end

			if AffDotsO.text == "absolute" then
				f.t1:SetText(current);f.t2:SetText(on_target)
			else
				f.t3:SetText(Round(current*100/on_target))
			end
		else
			f.cd:Hide();
			f.bg:SetTexture(colors[4][1],colors[4][2],colors[4][3],AffDotsO.transparency)
			if AffDotsO.text == "absolute" then
				f.t1:SetText(dot_damage[f.d.spell]);f.t2:SetText(0)
			else
				f.t3:SetText(100)
			end
		end
	elseif f.d.t == "debuff" then
		local _,_,_,_,_,duration,expires = UnitDebuff("target", f.d.spell_name,"","player")
		if(expires) then
			if not AffDotsO.hide_icons then f.cd:SetCooldown(expires-duration, duration);f.cd:Show();end
		else
			f.cd:Hide();
		end
		f.bg:SetTexture(colors[4][1],colors[4][2],colors[4][3],AffDotsO.transparency)

		if f.d.resource then
			if(UnitPower("player", player_resource_id) >= primary_resource_treshold) then
				f.bg:SetTexture(colors[1][1],colors[1][2],colors[1][3],AffDotsO.transparency)
			end
			f.t3:SetText(UnitPower("player", player_resource_id))
		end
	elseif f.d.t == "hp" then
		f.bg:SetTexture(colors[4][1],colors[4][2],colors[4][3],AffDotsO.transparency)
		if UnitExists(f.d.target) then
			local hp = Round(UnitHealth(f.d.target)*100/UnitHealthMax(f.d.target))
			f.t:SetText(hp)
			if execute_percent >= hp then
				f.bg:SetTexture(colors[1][1],colors[1][2],colors[1][3],AffDotsO.transparency)
			end
		end
	elseif f.d.t == "coe" then
		local _,_,_,_,_,_,expires1 = UnitDebuff(f.d.target, f.d.coe)
		local _,_,_,_,_,_,expires2 = UnitDebuff(f.d.target, f.d.poison)
		local expires = expires1 or expires2
		if expires then
			local time_remaining = expires - GetTime()
			if 		time_remaining>60 	then f.t:SetText(tostring(math.floor(time_remaining/60)+1).."m")
			elseif 	time_remaining>10	then f.t:SetText("0:" ..tostring(math.floor(time_remaining)))
			else 							 f.t:SetText("0:0"..tostring(math.floor(time_remaining)))
			end
			f.bg:SetTexture(colors[1][1],colors[1][2],colors[1][3],AffDotsO.transparency)
		else
			f.t:SetText("")
			f.bg:SetTexture(colors[4][1],colors[4][2],colors[4][3],AffDotsO.transparency)
		end
	end
end

local function Unlock(unlock)
	m:SetMovable(unlock)
	m:EnableMouse(unlock)
	f:SetMovable(unlock)
	f:EnableMouse(unlock)
end

local function Visibility()
	if AffDotsOptions:IsShown() then return end
	if(AffDotsO.hide and not in_combat) then
		m:Hide()
	else
		m:Show()
	end

	if(UnitGUID("focus") and AffDotsO.focus and (in_combat or not AffDotsO.hide)) then
		f:Show()
	else
		f:Hide()
	end
end

local function InitFrames()
	GetDotDmg()
	m:ClearAllPoints()
	f:ClearAllPoints()
	if(AffDotsO.layout == "horizontal") then
		m:SetSize(160*AffDotsO.scale, 70*AffDotsO.scale)
		f:SetSize(160*AffDotsO.focus_scale, 70*AffDotsO.focus_scale)
	else
		m:SetSize(80*AffDotsO.scale, 160*AffDotsO.scale)
		f:SetSize(80*AffDotsO.focus_scale, 160*AffDotsO.focus_scale)
	end
	if(AffDotsO.x and AffDotsO.y and AffDotsO.p and AffDotsO.rp) then
		m:SetPoint(AffDotsO.p, nil, AffDotsO.rp, AffDotsO.x, AffDotsO.y)
	else
		m:SetPoint("CENTER", 0, 0)
	end
	if(AffDotsO.focus_x and AffDotsO.focus_y and AffDotsO.focus_p and AffDotsO.focus_rp) then
		f:SetPoint(AffDotsO.focus_p, nil, AffDotsO.focus_rp, AffDotsO.focus_x, AffDotsO.focus_y)
	else
		f:SetPoint("CENTER", 0, 100)
	end
	
	m.f1:Hide();m.f2:Hide();m.f3:Hide();m.f4:Hide();m.f5:Hide();m.f6:Hide();
	f.f1:Hide();f.f2:Hide();f.f3:Hide();f.f4:Hide();f.f5:Hide();f.f6:Hide();
	m.f1:SetScale(AffDotsO.scale);f.f1:SetScale(AffDotsO.focus_scale);
	m.f2:SetScale(AffDotsO.scale);f.f2:SetScale(AffDotsO.focus_scale);
	m.f3:SetScale(AffDotsO.scale);f.f3:SetScale(AffDotsO.focus_scale);
	m.f4:SetScale(AffDotsO.scale);f.f4:SetScale(AffDotsO.focus_scale);
	m.f5:SetScale(AffDotsO.scale);f.f5:SetScale(AffDotsO.focus_scale);

	for k,v in pairs(active_frames) do
		active_frames[k] = nil
	end
	
	if class == "WARLOCK" then
		m.f5.d = {t="hp",target="target"}
		f.f5.d = {t="hp",target="focus"}
		m.f6.d = {t="coe",target="target",coe=GetSpellInfo(1490),poison=GetSpellInfo(93068)}
		f.f6.d = {t="coe",target="focus",coe=GetSpellInfo(1490),poison=GetSpellInfo(93068)}
		if spec == 1 then
			if AffDotsO.affliction == 0 then return end
			player_resource_id	= 7; primary_resource_treshold = 4; execute_percent = 20;
			m.f1.d = {t="dot",target="target",spell_id=980,pandemic=12,order=AffDotsO.agony_order}
			m.f2.d = {t="dot",target="target",spell_id=172,pandemic=9,order=AffDotsO.corr_order}
			m.f3.d = {t="dot",target="target",spell_id=30108,pandemic=7,order=AffDotsO.ua_order}
			m.f4.d = {t="debuff",target="target",spell_id=48181,order=AffDotsO.haunt_order,resource=true}
			f.f1.d = {t="dot",target="focus",spell_id=980,pandemic=12,order=AffDotsO.agony_order}
			f.f2.d = {t="dot",target="focus",spell_id=172,pandemic=9,order=AffDotsO.corr_order}
			f.f3.d = {t="dot",target="focus",spell_id=30108,pandemic=7,order=AffDotsO.ua_order}
			f.f4.d = {t="debuff",target="focus",spell_id=48181,order=AffDotsO.haunt_order,resource=true}

			active_frames["1"] = m.f1;active_frames["2"] = m.f2;active_frames["3"] = m.f3;
			if AffDotsO.haunt then active_frames["4"] = m.f4 end
			if AffDotsO.focus then
				active_frames["7"] = f.f1;active_frames["8"] = f.f2;active_frames["9"] = f.f3;
				if AffDotsO.haunt then active_frames["10"] = f.f4 end
			end
		elseif spec == 2 then
			if AffDotsO.demonology == 0 then return end
			player_resource_id	= 15; primary_resource_treshold = 800; execute_percent = 20;
			m.f1.d = {t="dot",target="target",spell_id=172,pandemic=9,order=AffDotsO.demo_corr}
			m.f2.d = {t="dot",target="target",spell_id=603,pandemic=30,order=AffDotsO.demo_doom}
			f.f1.d = {t="dot",target="focus",spell_id=172,pandemic=9,order=AffDotsO.demo_corr}
			f.f2.d = {t="dot",target="focus",spell_id=603,pandemic=30,order=AffDotsO.demo_doom}
			
			active_frames["1"] = m.f1;active_frames["2"] = m.f2;
			if AffDotsO.focus then
				active_frames["7"] = f.f1;active_frames["8"] = f.f2;
			end
		elseif spec == 3 then
			--return
			player_resource_id	= 14; primary_resource_treshold = 4; execute_percent = 20;
			m.f1.d = {t="dot",target="target",spell_id=348,pandemic=8,order=AffDotsO.destro_immo}
			f.f1.d = {t="dot",target="focus",spell_id=348,pandemic=8,order=AffDotsO.destro_immo}
			active_frames["1"] = m.f1
			if AffDotsO.focus then
				active_frames["7"] = f.f1
			end
		end
	end

	for k,v in pairs(active_frames) do 
		active_frames[k]:Show()
		local n,r,i = GetSpellInfo(active_frames[k].d.spell_id)
		active_frames[k].d["spell"] = tostring(active_frames[k].d.spell_id)
		active_frames[k].d["rank"] = r
		active_frames[k].d["spell_name"] = n
		if AffDotsO.hide_icons then
			active_frames[k].icon:SetTexture(nil)
		else
			active_frames[k].icon:SetTexture(i)
		end
		if AffDotsO.hide_text then 
			active_frames[k].t1:Hide();active_frames[k].t2:Hide();active_frames[k].t3:Hide();
		else
			active_frames[k].t1:Show();active_frames[k].t2:Show();active_frames[k].t3:Show();
		end
		active_frames[k].t1:SetText("");active_frames[k].t2:SetText("");active_frames[k].t3:SetText("");
		if(AffDotsO.layout == "horizontal") then
			active_frames[k]:SetSize(40, 70)
			active_frames[k]:SetPoint("TOPLEFT", active_frames[k].d.order*40, 0)
			active_frames[k].t1:SetPoint("TOPRIGHT", -5, -5-(AffDotsO.icon_pos*35))
			active_frames[k].t2:SetPoint("TOPRIGHT", -5, -20-(AffDotsO.icon_pos*35))
			active_frames[k].t3:ClearAllPoints()
			active_frames[k].t3:SetPoint("TOP", 0, -13-(AffDotsO.icon_pos*32))
			active_frames[k].icon:SetPoint("TOPLEFT", 5, -35+(AffDotsO.icon_pos*30))
		else
			active_frames[k]:SetSize(80, 40)
			active_frames[k]:SetPoint("TOPLEFT", 0, active_frames[k].d.order*-40)
			active_frames[k].t1:SetPoint("TOPRIGHT", -7-(AffDotsO.icon_pos*40), -8)
			active_frames[k].t2:SetPoint("TOPRIGHT", -7-(AffDotsO.icon_pos*40), -23)
			active_frames[k].t3:ClearAllPoints()
			active_frames[k].t3:SetPoint("RIGHT", -8-(AffDotsO.icon_pos*30), 0)
			active_frames[k].icon:SetPoint("TOPLEFT", 5+(AffDotsO.icon_pos*40), -5)
		end
		active_frames[k].bg:SetAllPoints(active_frames[k])
		active_frames[k].cd:SetAllPoints(active_frames[k].icon)
	end
	
	if(AffDotsO.coe) then
		if AffDotsO.hp then 
			m.f6:SetPoint("TOPLEFT", 40, 22);f.f6:SetPoint("TOPLEFT", 40, 22);
		else
			m.f6:SetPoint("TOPLEFT",  0, 22);f.f6:SetPoint("TOPLEFT",  0, 22);
		end
		m.f6:SetScale(AffDotsO.scale);f.f6:SetScale(AffDotsO.focus_scale);
		m.f6.t:SetPoint("TOPLEFT", 10, -5);f.f6.t:SetPoint("TOPLEFT", 10, -5);
		active_frames["6"] = m.f6; m.f6:Show();
		if(AffDotsO.focus) then active_frames["12"] = f.f6; f.f6:Show(); end
	end
	
	if(AffDotsO.hp) then
		m.f5:SetPoint("TOPLEFT", 0, 22);m.f5:SetScale(AffDotsO.scale);
		f.f5:SetPoint("TOPLEFT", 0, 22);f.f5:SetScale(AffDotsO.focus_scale);
		m.f5.t:SetPoint("TOPLEFT", 10, -5);f.f5.t:SetPoint("TOPLEFT", 10, -5);
		active_frames["5"] = m.f5; m.f5:Show();
		if(AffDotsO.focus) then active_frames["11"] = f.f5; f.f5:Show(); end
	end
end

function AffDotsOpenColorPicker( b, c )
	ColorPickerFrame:Hide()
	button = b
	color_type = c
	ColorPickerFrame:SetColorRGB(colors[color_type][1], colors[color_type][2], colors[color_type][3])
	restore = colors[color_type]

	ColorPickerFrame.func =
		function ()
			local r,g,b = ColorPickerFrame:GetColorRGB()
			AffDotsO["color"..tostring(color_type)] = {r,g,b}; colors[color_type] = {r,g,b};
			getglobal(button:GetName() .. "Color"):SetVertexColor(r,g,b)
		end
	ColorPickerFrame.cancelFunc =
		function ()
			AffDotsO["color"..tostring(color_type)] = restore; colors[color_type] = restore;
			getglobal(button:GetName() .. "Color"):SetVertexColor(colors[color_type][1], colors[color_type][2], colors[color_type][3])
		end
	ColorPickerFrame:Show()
end

local function OptionsFrameFunctions()
	AffDotsOptEnableAffliction:SetChecked(AffDotsO.affliction)
	AffDotsOptEnableDemonology:SetChecked(AffDotsO.demonology)
	AffDotsOptHide:SetChecked(AffDotsO.hide)
	AffDotsOptHorizontal:SetChecked(AffDotsO.layout=="horizontal")
	AffDotsOptTextType:SetChecked(AffDotsO.text=="relative")
	AffDotsOptNoText:SetChecked(AffDotsO.hide_text)	
	AffDotsOptIconPosition:SetChecked(AffDotsO.icon_pos)
	AffDotsOptNoIcons:SetChecked(AffDotsO.hide_icons)
	AffDotsOptFocus:SetChecked(AffDotsO.focus)
	AffDotsOptCoE:SetChecked(AffDotsO.coe)
	AffDotsOptHp:SetChecked(AffDotsO.hp)
	AffDotsOptHaunt:SetChecked(AffDotsO.haunt)
	AffDotsOptScaleSlider:SetValue(AffDotsO.scale)
	getglobal(AffDotsOptScaleSlider:GetName() .. 'Text'):SetText(AffDotsO.scale)
	AffDotsOptFScaleSlider:SetValue(AffDotsO.focus_scale)
	getglobal(AffDotsOptFScaleSlider:GetName() .. 'Text'):SetText(AffDotsO.focus_scale)
	AffDotsOptColorSwitch:SetValue((AffDotsO.color_switch-1)*100)
	getglobal(AffDotsOptColorSwitch:GetName() .. 'Text'):SetText((AffDotsO.color_switch-1)*100)
	AffDotsOptAlpha:SetValue(AffDotsO.transparency)
	getglobal(AffDotsOptAlpha:GetName() .. 'Text'):SetText(AffDotsO.transparency)
	AffDotsOptOrderAgony:SetValue(AffDotsO.agony_order+1)
	getglobal(AffDotsOptOrderAgony:GetName() .. 'Text'):SetText(AffDotsO.agony_order+1)
	AffDotsOptOrderCorr:SetValue(AffDotsO.corr_order+1)
	getglobal(AffDotsOptOrderCorr:GetName() .. 'Text'):SetText(AffDotsO.corr_order+1)
	AffDotsOptOrderUA:SetValue(AffDotsO.ua_order+1)
	getglobal(AffDotsOptOrderUA:GetName() .. 'Text'):SetText(AffDotsO.ua_order+1)
	AffDotsOptOrderHaunt:SetValue(AffDotsO.haunt_order+1)
	getglobal(AffDotsOptOrderHaunt:GetName() .. 'Text'):SetText(AffDotsO.haunt_order+1)
	getglobal(AffDotsOptColor1:GetName() .. "Color"):SetVertexColor(colors[1][1], colors[1][2], colors[1][3])
	getglobal(AffDotsOptColor2:GetName() .. "Color"):SetVertexColor(colors[2][1], colors[2][2], colors[2][3])
	getglobal(AffDotsOptColor3:GetName() .. "Color"):SetVertexColor(colors[3][1], colors[3][2], colors[3][3])
	getglobal(AffDotsOptColor4:GetName() .. "Color"):SetVertexColor(colors[4][1], colors[4][2], colors[4][3])
	getglobal(AffDotsOptColor6:GetName() .. "Color"):SetVertexColor(colors[6][1], colors[6][2], colors[6][3])
	getglobal(AffDotsOptColor7:GetName() .. "Color"):SetVertexColor(colors[7][1], colors[7][2], colors[7][3])
	AffDotsOptions:EnableMouse(true)
	AffDotsOptions:SetMovable(true)
	AffDotsOptions:RegisterForDrag("LeftButton")
	AffDotsOptions:SetScript("OnDragStart", function(self) self:StartMoving() end)
	AffDotsOptions:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing()
		self:SetUserPlaced(false)
	end)
	
	AffDotsOptEnableAffliction:SetScript("OnClick", function(self)
		AffDotsO.affliction = math.abs(AffDotsO.affliction-1)
		InitFrames()
	end)
	
	AffDotsOptEnableDemonology:SetScript("OnClick", function(self)
		AffDotsO.demonology = math.abs(AffDotsO.demonology-1)
		InitFrames()
	end)

	AffDotsOptHide:SetScript("OnClick", function(self)
		AffDotsO.hide = not AffDotsO.hide
	end)

	AffDotsOptHorizontal:SetScript("OnClick", function(self)
		if(AffDotsO.layout == "horizontal") then
			AffDotsO.layout = "vertical"
		else
			AffDotsO.layout = "horizontal"
		end
		InitFrames()
	end)
	
	AffDotsOptTextType:SetScript("OnClick", function(self)
		if(AffDotsO.text == "absolute") then
			AffDotsO.text = "relative"
		else
			AffDotsO.text = "absolute"
		end
		InitFrames()
	end)
	
	AffDotsOptIconPosition:SetScript("OnClick", function(self)
		AffDotsO.icon_pos = math.abs(AffDotsO.icon_pos-1)
		InitFrames()
	end)
	
	AffDotsOptNoText:SetScript("OnClick", function(self)
		AffDotsO.hide_text = not AffDotsO.hide_text
		InitFrames()
	end)
	
	AffDotsOptNoIcons:SetScript("OnClick", function(self)
		AffDotsO.hide_icons = not AffDotsO.hide_icons
		InitFrames()
	end)
	
	AffDotsOptFocus:SetScript("OnClick", function(self)
		AffDotsO.focus = not AffDotsO.focus
		InitFrames()
	end)
	
	AffDotsOptCoE:SetScript("OnClick", function(self)
		AffDotsO.coe = not AffDotsO.coe
		InitFrames()
	end)
	
	AffDotsOptHp:SetScript("OnClick", function(self)
		AffDotsO.hp = not AffDotsO.hp
		InitFrames()
	end)
	
	AffDotsOptHaunt:SetScript("OnClick", function(self)
		AffDotsO.haunt = not AffDotsO.haunt
		InitFrames()
	end)
	

	AffDotsOptScaleSlider:SetScript("OnValueChanged", function()
		AffDotsO.scale = Round(AffDotsOptScaleSlider:GetValue()*10)/10
		getglobal(AffDotsOptScaleSlider:GetName() .. 'Text'):SetText(AffDotsO.scale)
		InitFrames()
	end)

	AffDotsOptFScaleSlider:SetScript("OnValueChanged", function()
		AffDotsO.focus_scale = Round(AffDotsOptFScaleSlider:GetValue()*10)/10
		getglobal(AffDotsOptFScaleSlider:GetName() .. 'Text'):SetText(AffDotsO.focus_scale)
		InitFrames()
	end)
	
	AffDotsOptAlpha:SetScript("OnValueChanged", function()
		AffDotsO.transparency = Round(AffDotsOptAlpha:GetValue()*10)/10
		getglobal(AffDotsOptAlpha:GetName() .. 'Text'):SetText(AffDotsO.transparency)
		InitFrames()
	end)

	AffDotsOptOrderHaunt:SetScript("OnValueChanged", function()
		AffDotsO.haunt_order = Round(AffDotsOptOrderHaunt:GetValue())-1
		getglobal(AffDotsOptOrderHaunt:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderHaunt:GetValue()))
		InitFrames();
	end)

	AffDotsOptOrderAgony:SetScript("OnValueChanged", function()
		AffDotsO.agony_order = Round(AffDotsOptOrderAgony:GetValue())-1
		getglobal(AffDotsOptOrderAgony:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderAgony:GetValue()))
		InitFrames();
	end)

	AffDotsOptOrderCorr:SetScript("OnValueChanged", function()
		AffDotsO.corr_order = Round(AffDotsOptOrderCorr:GetValue())-1
		getglobal(AffDotsOptOrderCorr:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderCorr:GetValue()))
		InitFrames();
	end)

	AffDotsOptOrderUA:SetScript("OnValueChanged", function()
		AffDotsO.ua_order = Round(AffDotsOptOrderUA:GetValue())-1
		getglobal(AffDotsOptOrderUA:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderUA:GetValue()))
		InitFrames();
	end)

	AffDotsOptColorSwitch:SetScript("OnValueChanged", function()
		AffDotsO.color_switch = 1 + Round(AffDotsOptColorSwitch:GetValue())/100
		getglobal(AffDotsOptColorSwitch:GetName() .. 'Text'):SetText((AffDotsO.color_switch-1)*100);
	end)

	AffDotsOptReset:SetScript("OnClick", function()
		AffDotsO.x = nil
		AffDotsO.y = nil
		AffDotsO.p = nil
		AffDotsO.rp = nil
		AffDotsO.focus_x = nil
		AffDotsO.focus_y = nil
		AffDotsO.focus_p = nil
		AffDotsO.focus_rp = nil
		InitFrames()
	end)
	
	AffDotsOptClose:SetScript("OnClick", function()
		AffDotsOptions:Hide()
		Unlock(false)
		Visibility()
	end)
end

local function CleanTargets(force)
	local t = GetTime()
	for k,v in pairs(targets) do
		if not force then
			if targets[k][2] < t-100 then targets[k]=nil end
		else
			targets[k]=nil
		end
	end
end

local function onUpdate(self,elapsed)
    timer = timer + elapsed;
    if timer >= 0.2 then
		for k,v in pairs(active_frames) do
			SetText(active_frames[k])
		end
        timer = 0
    end
end

local function Events()
	if(select(2, UnitClass("player")) == "WARLOCK") then
		m:RegisterEvent("COMBAT_LOG_EVENT")
		CombatLogAddFilter("SPELL_DAMAGE,SPELL_AURA_APPLIED,SPELL_AURA_REFRESH", me)
		m:RegisterEvent("PLAYER_REGEN_ENABLED")
		m:RegisterEvent("PLAYER_REGEN_DISABLED")
		m:RegisterEvent("COMBAT_RATING_UPDATE")
		m:RegisterEvent("SPELL_POWER_CHANGED")
		m:RegisterEvent("PLAYER_DAMAGE_DONE_MODS")
		m:RegisterEvent("PLAYER_FOCUS_CHANGED")
		m:SetScript("OnUpdate", onUpdate)
	else
		m:SetScript("OnUpdate", nil)
		m:UnregisterEvent("SPELL_POWER_CHANGED")
		m:UnregisterEvent("COMBAT_RATING_UPDATE")
		m:UnregisterEvent("PLAYER_DAMAGE_DONE_MODS")
		m:UnregisterEvent("PLAYER_REGEN_DISABLED")
		m:UnregisterEvent("PLAYER_REGEN_ENABLED")
		m:UnregisterEvent("PLAYER_FOCUS_CHANGED")
		m:UnregisterEvent("COMBAT_LOG_EVENT")
		m:Hide()
		return
	end
end

SLASH_AFFDOTS1 = '/affdots'
function AffDotsHandler(msg, editBox)
	Unlock(true)
	m:Show();f:Show();
	AffDotsOptions:Show()
	Visibility()
end
SlashCmdList["AFFDOTS"] = AffDotsHandler

local function VariablesLoaded()
	colors = {AffDotsO.color1,AffDotsO.color2,AffDotsO.color3,AffDotsO.color4,0,AffDotsO.color6,AffDotsO.color7}
	OptionsFrameFunctions()
	Unlock(false)
	Visibility()
end
function AffDotsOnEvent(frame, event, ...)
	if event == "COMBAT_LOG_EVENT" then
		_,event_type,_,source_GUID,_,_,_,dest_GUID,_,_,_,spell = select(1, ...)
		if(dest_GUID ~= me) then CombatLog(event_type,spell,dest_GUID) end
	elseif(event == "PLAYER_DAMAGE_DONE_MODS" or event == "COMBAT_RATING_UPDATE" or event == "SPELL_POWER_CHANGED") then
		GetDotDmg()
	elseif event == "PLAYER_REGEN_ENABLED" then
		in_combat = false; Visibility()
		CleanTargets(false)
	elseif event == "PLAYER_REGEN_DISABLED" then
		in_combat = true; Visibility()
	elseif event == "PLAYER_FOCUS_CHANGED" then
		Visibility()
	elseif event == "VARIABLES_LOADED" then
		VariablesLoaded()
	elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
		spec 	= GetSpecialization()
		CleanTargets(true)
		Events()
		InitFrames()
	elseif (event == "PLAYER_ALIVE" or event == "PLAYER_ENTERING_WORLD") then
		me = UnitGUID("player")
		class 	= select(2, UnitClass("player"))
		spec 	= GetSpecialization()
		Events()
		InitFrames()
	end
end